/*
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * Emulations of the ED operations of the Z80 CPU instruction set
 * - part of xz80. Copyright (C) 1994 Ian Collier.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// Note: Timings in this module INCLUDE the ED prefix timing - no they don't any more!

#define edinstr(opcode,cycles)		case opcode:															\
									{

#define edinstr2(opcode,u_cycles,c_cycles)																	\
									case opcode:															\
									{

#define input(reg)	{																						\
						reg = in_byte(bc);																	\
						f = (f & 1) | (reg & 0xa8) | ((!reg) << 6) | parity(reg);							\
					}

#define C_PORT_ACCESS			do { if (c >= 0xf8) g_nLineCycle +=4; PORT_ACCESS(c); } while (0)

#define in_out_c_instr(opcode)	case opcode:																	\
								{																				\
									C_PORT_ACCESS;

#define inx_instr(opcode)		case opcode:																	\
								{

#define outx_instr(opcode)		case opcode:																	\
								{


#define sbchl(x) {    g_nLineCycle += 8;\
					  WORD z=(x);\
                      unsigned long t=(hl-z-cy)&0x1ffff;\
                      f=((t>>8)&0xa8)|(t>>16)|2|\
                        (((hl&0xfff)<(z&0xfff)+cy)<<4)|\
                        (((hl^z)&(hl^t)&0x8000)>>13)|\
                        ((!(t&0xffff))<<6)|2;\
                      l=t;\
                      h=t>>8;\
                   }

#define adchl(x) {    g_nLineCycle += 8;\
					  WORD z=(x);\
                      unsigned long t=hl+z+cy;\
                      f=((t>>8)&0xa8)|(t>>16)|\
                        (((hl&0xfff)+(z&0xfff)+cy>0xfff)<<4)|\
                        (((~hl^z)&(hl^t)&0x8000)>>13)|\
                        ((!(t&0xffff))<<6)|2;\
                      l=t;\
                      h=t>>8;\
                 }

#define neg (a=-a,\
            f=(a&0xa8)|((!a)<<6)|(((a&15)>0)<<4)|((a==128)<<2)|2|(a>0))

{
	BYTE op=timed_read_byte(pc);
	pc++;
	radjust++;

	switch(op)
	{

// in b,(c)
in_out_c_instr(0x40);
	input(b);
endinstr;

// out (c),b
in_out_c_instr(0x41);
	out_byte(bc,b);
endinstr;

// sbc hl, bc
edinstr2(0x42,16,24);
	sbchl(bc);
endinstr;

// ld (nn), bc
edinstr(0x43,24);
{
	WORD addr=timed_read_word(pc);
	pc += 2;
	timed_write_word(addr,bc);
}
endinstr;

// neg
edinstr(0x44,8);
	neg;
endinstr;

// retn
edinstr(0x45,16);
	retn;
endinstr;

// im 0
edinstr(0x46,8);
	im = 0;
endinstr;

// ld i,a
edinstr2(0x47,12,16);
	i = a;
	g_nLineCycle += 4;
endinstr;

// in c,(c)
in_out_c_instr(0x48);
	input(c);
endinstr;

// out (c),c
in_out_c_instr(0x49);
	out_byte(bc,c);
endinstr;

// adc hl,bc
edinstr2(0x4a,16,24);
	adchl(bc);
endinstr;

// ld bc,(nn)
edinstr(0x4b,24);
{
	WORD addr = timed_read_word(pc);
	pc += 2;
	bc = timed_read_word(addr);
}
endinstr;


// neg
edinstr(0x4c,8);
	neg;
endinstr;

// retn
edinstr(0x4d,16);
	retn;
endinstr;

// im 0/1
edinstr(0x4e,8);
	im = 0;
endinstr;

// ld r,a
edinstr2(0x4f,12,16);
	radjust = r = a;
	g_nLineCycle += 4;
endinstr;


// in d,(c)
in_out_c_instr(0x50);
	input(d);
endinstr;

// out (c),d
in_out_c_instr(0x51);
	out_byte(bc,d);
endinstr;

// sbc hl,de
edinstr2(0x52,16,24);
	sbchl(de);
endinstr;

// ld (nn),de
edinstr(0x53,24);
{
	WORD addr=timed_read_word(pc);
	pc += 2;
	timed_write_word(addr,de);
}
endinstr;


// neg
edinstr(0x54,8);
	neg;
endinstr;

// retn
edinstr(0x55,16);
	retn;
endinstr;

// im 1
edinstr(0x56,8);
	im = 1;
endinstr;

// ld a,i
edinstr2(0x57,12,16);
	a = i;
	f = (f & 1) | (a & 0xa8) | ((!a) << 6) | (iff2 << 2);
	g_nLineCycle += 4;
endinstr;

// in e,(c)
in_out_c_instr(0x58);
	input(e);
endinstr;

// out (c),e
in_out_c_instr(0x59);
	out_byte(bc,e);
endinstr;

// adc hl,de
edinstr2(0x5a,16,24);
	adchl(de);
endinstr;

// ld de,(nn)
edinstr(0x5b,24);
{
	WORD addr = timed_read_word(pc);
	pc += 2;
	de = timed_read_word(addr);
}
endinstr;

// neg
edinstr(0x5c,8);
	neg;
endinstr;

// retn
edinstr(0x5d,16);
	retn;
endinstr;

// im 2
edinstr(0x5e,8);
	im = 2;
endinstr;

// ld a,r
edinstr2(0x5f,12,16);
{
	// only the bottom 7 bits of R are advanced by memory refresh, so the top bit is preserved
	r = (r & 0x80) | (radjust & 0x7f);
	a = r;
	f = (f & 1) | (a & 0xa8) | ((!a) << 6) | (iff2 << 2);
	g_nLineCycle += 4;
}
endinstr;


// in h,(c)
in_out_c_instr(0x60);
	input(h);
endinstr;

// out (c),h
in_out_c_instr(0x61);
	out_byte(bc,h);
endinstr;

// sbc hl,hl
edinstr2(0x62,16,24);
	sbchl(hl);
endinstr;

// ld (nn), hl
edinstr(0x63,24);
{
	WORD addr=timed_read_word(pc);
	pc += 2;
	timed_write_word(addr,hl);
}
endinstr;

// neg
edinstr(0x64,8);
	neg;
endinstr;

// reti
edinstr(0x65,16);
	ret;
endinstr;

// im 0
edinstr(0x66,8);
	im = 0;
endinstr;

// rrd
edinstr2(0x67,20,32);
{
	BYTE t=timed_read_byte(hl);
	BYTE u=(a<<4)|(t>>4);
	a=(a&0xf0)|(t&0x0f);
	timed_write_byte(hl,u);
	f=(f&1)|(a&0xa8)|((!a)<<6)|parity(a);
	g_nLineCycle += 4;
}
endinstr;


// in l,(c)
in_out_c_instr(0x68);
	input(l);
endinstr;

// out (c),l
in_out_c_instr(0x69);
	out_byte(bc,l);
endinstr;

// adc hl,hl
edinstr2(0x6a,16,24);
	adchl(hl);
endinstr;

// ld hl,(nn)
edinstr(0x6b,24);
{
	WORD addr = timed_read_word(pc);
	pc += 2;
	hl = timed_read_word(addr);
}
endinstr;


// neg
edinstr(0x6c,8);
	neg;
endinstr;

// reti
edinstr(0x6d,16);
	ret;
endinstr;

// im 0/1
edinstr(0x6e,8);
	im = 0;
endinstr;

// rld
edinstr2(0x6f,20,32);
{
	BYTE t = timed_read_byte(hl);
	BYTE u = (a & 0x0f) | (t << 4);
	a = (a & 0xf0) | (t >> 4);
	timed_write_byte(hl,u);
	f = (f & 1) | (a & 0xa8) | ((!a) << 6) | parity(a);
	g_nLineCycle += 4;
}
endinstr;


// in x,(c)	  [result discarded, but flags still set]
in_out_c_instr(0x70);
{
	BYTE x;
	input(x);
}
endinstr;

// out (c),0	[output zero]
in_out_c_instr(0x71);
	out_byte(bc,0);
endinstr;

// sbc hl,sp
edinstr2(0x72,16,24);
	sbchl(sp);
endinstr;

// ld (nn),sp
edinstr(0x73,24);
{
	WORD addr=timed_read_word(pc);
	pc += 2;
	timed_write_word(addr,sp);
}
endinstr;


// neg
edinstr(0x74,8);
	neg;
endinstr;

// reti
edinstr(0x75,16);
	ret;
endinstr;

// im 1
edinstr(0x76,8);
	im = 1;
endinstr;


// nop for 0x77


// in a,(c)
in_out_c_instr(0x78);
	input(a);
endinstr;

// out (c),a
in_out_c_instr(0x79);
	out_byte(bc,a);
endinstr;

// adc hl,sp
edinstr2(0x7a,16,24);
	adchl(sp);
endinstr;

// ld sp,(nn)
edinstr(0x7b,24);
{
	WORD addr = timed_read_word(pc);
	pc += 2;
	sp = timed_read_word(addr);
}
endinstr;

// neg
edinstr(0x7c,8);
	neg;
endinstr;

// reti
edinstr(0x7d,16);
	ret;
endinstr;

// im 2
edinstr(0x7e,8);
	im = 2;
endinstr;

// nop for 0x7f to 0x9f

// ldi
edinstr2(0xa0,20,32);
{
	BYTE x = timed_read_byte(hl);
	timed_write_byte(de,x);
	g_nLineCycle += 4;

	hl++;
	de++;
	bc--;
	f = (f & 0xc1) | (x & 0x28) | (((b | c) > 0) << 2);
}
endinstr;

// cpi
edinstr2(0xa1,16,24);
{
	BYTE carry = cy;
	cpa(timed_read_byte(hl));
	g_nLineCycle += 4;

	hl++;
	bc--;
	f = (f & 0xfa) | carry | (((b | c) > 0) << 2);
}
endinstr;

// ini
inx_instr(0xa2);
{
	g_nLineCycle += 4;
	PORT_ACCESS(c);
	BYTE t = in_byte(bc);
	timed_write_byte(hl,t);

	hl++;
	b--;
	f = (b & 0xa8) | ((!b) << 6) | 2 | ((parity(b) ^ c) & 4);	// fixed - zero flag set when B becomes zero (Si Owen)
}
endinstr;

// outi
outx_instr(0xa3);
{
// I can't determine the correct flags outcome for the block OUT instructions.
// Spec says that the carry flag is left unchanged and N is set to 1, but that
// doesn't seem to be the case...

	BYTE x = timed_read_byte(hl);
	b--;
	C_PORT_ACCESS;
	out_byte(bc,x);

	hl++;
	f = (f & 1) | 0x12 | (b & 0xa8) | ((!b) << 6);
}
endinstr;

// nop for 0xa4 -> 0xa7

// ldd
edinstr2(0xa8,20,32);
{
	BYTE x = timed_read_byte(hl);
	timed_write_byte(de,x);
	g_nLineCycle += 4;

	hl--;
	de--;
	bc--;
	f = (f & 0xc1) | (x & 0x28) | (((b | c) > 0) << 2);
}
endinstr;

// cpd
edinstr2(0xa9,16,24);
{
	BYTE carry = cy;
	cpa(timed_read_byte(hl));
	g_nLineCycle += 4;

	hl--;
	bc--;
	f = (f & 0xfa) | carry | (((b | c) > 0) << 2);
}
endinstr;

// ind
inx_instr(0xaa);
{
	g_nLineCycle += 4;
	PORT_ACCESS(c);
	BYTE t = in_byte(bc);
	timed_write_byte(hl,t);

	hl--;
	b--;
	f = (b & 0xa8) | ((!b) << 6) | 2 | ((parity(b) ^ c ^ 4) & 4);	// fixed - zero flag set when B becomes zero (Si Owen)
}
endinstr;

// outd
outx_instr(0xab);
{
	BYTE x = timed_read_byte(hl);
	b--;
	C_PORT_ACCESS;
	out_byte(bc,x);

	hl--;
	f = (f & 1) | 0x12 | (b & 0xa8) | ((!b) << 6);
}
endinstr;

// nop for 0xac -> 0xaf



// Note: the Z80 implements "*R" as "*" followed by JR -2.  No reason to change this...

// ldir
edinstr2(0xb0,24,40);
{
	BYTE x = timed_read_byte(hl);
	timed_write_byte(de,x);
	g_nLineCycle += 4;

	hl++;
	de++;
	bc--;
	f = (f & 0xc1) | (x & 0x28) | (((b | c) > 0) << 2);

	if(b|c) {
		MEM_ACCESS(pc - 1);
		pc -= 2;
	}
}
endinstr;

// cpir
edinstr2(0xb1,24,32);
{
	BYTE carry = cy;
	cpa(timed_read_byte(hl));
	g_nLineCycle += 4;

	hl++;
	bc--;
	f = (f & 0xfa) | carry | (((b | c) > 0) << 2);

	if ((f & 0x44) == 4) {
		MEM_ACCESS(pc - 1);
		pc -= 2;
		g_nLineCycle += 4;
	}
}
endinstr;

// inir
edinstr(0xb2,24);
{
	g_nLineCycle += 4;
	PORT_ACCESS(c);
	BYTE t=in_byte(bc);
	timed_write_byte(hl,t);

	hl++;
	b--;
	f = (b & 0xa8) | ((b > 0) << 6) | 2 | ((parity(b) ^ c) & 4);

	if(b) {
		g_nLineCycle += 4;
		pc -= 2;
	}
}
endinstr;

// otir
edinstr2(0xb3,24,32);
{
	BYTE x = timed_read_byte(hl);
	b--;
	C_PORT_ACCESS;
	out_byte(bc,x);

	hl++;
	f = (f & 1) | 0x12 | (b & 0xa8) | ((!b) << 6);

	if (b) {
		g_nLineCycle += 4;
		pc -= 2;
	}
}
endinstr;

// nop for 0xb4 -> 0xb7


// lddr
edinstr2(0xb8,24,40);
{
	BYTE x=timed_read_byte(hl);
	timed_write_byte(de,x);
	g_nLineCycle += 4;

	hl--;
	de--;
	bc--;
	f = (f & 0xc1) | (x & 0x28) | (((b | c) > 0) << 2);

	if (b | c) {
		MEM_ACCESS(pc - 1);
		pc -= 2;
	}
}
endinstr;

// cpdr
edinstr2(0xb9,24,32);
{
	BYTE carry = cy;
	cpa(timed_read_byte(hl));
	g_nLineCycle += 4;

	hl--;
	bc--;
	f = (f & 0xfa) | carry | (((b | c) > 0) <<2 );

	if ((f & 0x44) == 4) {
		MEM_ACCESS(pc - 1);
		pc -= 2;
		g_nLineCycle += 4;
	}
}
endinstr;

// indr
edinstr(0xba,24);
{
	g_nLineCycle += 4;
	PORT_ACCESS(c);
	BYTE t = in_byte(bc);
	timed_write_byte(hl,t);

	hl--;
	b--;
	f = (b & 0xa8) | ((b > 0) << 6) | 2 | ((parity(b) ^ c ^ 4) & 4);

	if (b) {
		g_nLineCycle += 4;
		pc -= 2;
	}
}
endinstr;

// otdr
edinstr2(0xbb,24,32);
{
	BYTE x=timed_read_byte(hl);
	b--;
	C_PORT_ACCESS;
	out_byte(bc,x);

	hl--;

	f = (f & 1) | 0x12 | (b & 0xa8) | ((!b) << 6);
	if (b) {
		g_nLineCycle += 4;
		pc -= 2;
	}
}
endinstr;

// nop for 0xbc -> 0xff

// Anything not explicitly handled is effectively a 2 byte NOP (with predictable timing) (that's already accounted for)
default:
	break;
}
}
