/*
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * Emulations of the Z80 CPU instruction set - part of xz80.
 * Copyright (C) 1994 Ian Collier.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


// Disable the 'conversion from x to y, possible loss of data' warning until they're corrected
#ifdef _WIN32
#pragma warning(disable : 4244)
#endif

////////////////////////////////////////////////////////////////////////////////
//	H E L P E R   M A C R O S

/*
#define instr(opcode,cycles)	case opcode:																	\
								{																				\
									tstates = fContended ? T_ROUND(cycles) << 1 : T_ROUND(cycles)
*/
#define instr(opcode,cycles)	case opcode:																	\
								{

#define instr0(opcode)			case opcode:																	\
								{
/*
#define instr2(opcode,u_cycles,c_cycles)																		\
								case opcode:																	\
								{																				\
									tstates = fContended ? T_ROUND(c_cycles) : T_ROUND(u_cycles)
*/
#define instr2(opcode,u_cycles,c_cycles)																		\
								case opcode:																	\
								{
/*
#define HLinstr(opcode,cycles,morecycles)																		\
								case opcode:																	\
								{																				\
									tstates = fContended ? T_ROUND(cycles) << 1 : T_ROUND(cycles);				\
																												\
									WORD addr;																	\
									if (pHlIxIy == &hl)															\
										addr=hl;																\
									else																		\
									{																			\
                                        tstates += fContended ? T_ROUND(morecycles) << 1 : T_ROUND(morecycles);	\
										addr = *pHlIxIy + (signed char)read_byte(pc);							\
										pc++;																	\
									}
*/
#define HLinstr(opcode,cycles,morecycles)																		\
								case opcode:																	\
								{																				\
									WORD addr;																	\
									if (pHlIxIy == &hl)															\
										addr=hl;																\
									else																		\
									{																			\
										addr = *pHlIxIy + (signed char)timed_read_byte(pc);						\
                                        g_nLineCycle += morecycles - 4;											\
										pc++;																	\
									}

#define endinstr				}; break

#define cy	(f & F_CARRY)

#define xh	(((BYTE*)pHlIxIy)[1])
#define xl	(((BYTE*)pHlIxIy)[0])


// 8-bit increment
#define inc(var)	( var++, f = (f & F_CARRY) | (var & 0xa8) | ((!(var & 15)) << 4)|((!var) << 6) | ((var == 128) << 2) )

// 8-bit decrement
#define dec(var)	( f=(f&1)|((!(var&15))<<4)|2, --var, f |= (var & 0xa8) | ((var == 127) << 2) | ((!var) << 6) )


// add hl/ix/iy,dd
#define addhl(hi,lo)	g_nLineCycle += 8;															\
						if(pHlIxIy == &hl)															\
						{																			\
							WORD t;																	\
							l = t = l + (lo);														\
							f = (f & 0xc4) | (((t >>= 8) + (h & 0x0f) + ((hi) & 0x0f) > 15) << 4);	\
							h = (t += h + (hi));													\
							f |= (h & 0x28) | (t >> 8);												\
						}																			\
						else																		\
							do																		\
							{																		\
								WORD t = *pHlIxIy;													\
								f = (f&0xc4) | (((t & 0xfff) + ((hi << 8) | lo) > 0xfff) << 4);		\
								t += (hi << 8) | lo;												\
								*pHlIxIy = t;											   			\
								f |= ((t >> 8) & 0x28) | (t >> 16);									\
							} while(0)


#define adda1(x,c) /* 8-bit add */ do{WORD y;\
                      BYTE z=(x);\
                      y=a+z+(c);\
                      f=(y&0xa8)|(y>>8)|(((a&0x0f)+(z&0x0f)+(c)>15)<<4)|(((~a^z)&0x80&(y^a))>>5);\
                      f|=(!(a=y))<<6;\
                   } while(0)

#define adda(x)		adda1((x),0)
#define adca(x)		adda1((x),cy)

#define suba1(x,c) /* 8-bit subtract */ do{WORD y;\
                      BYTE z=(x);\
                      y=(a-z-(c))&0x1ff;\
                      f=(y&0xa8)|(y>>8)|(((a&0x0f)<(z&0x0f)+(c))<<4)|\
                        (((a^z)&0x80&(y^a))>>5)|2;\
                      f|=(!(a=y))<<6;\
                   } while(0)

#define suba(x)		suba1((x),0)
#define sbca(x)		suba1((x),cy)

// Undocumented flags added by Ian Collier
#define cpa(x) /* 8-bit compare */ do{WORD y;\
                      BYTE z=(x);\
                      y=(a-z)&0x1ff;\
                      f=(y&0x80)|(z&0x28)|(y>>8)|(((a&0x0f)<(z&0x0f))<<4)|\
                        (((a^z)&0x80&(y^a))>>5)|2|((!y)<<6);\
                   } while(0)

#define anda(x) /* logical and */ do{\
                      a&=(x);\
                      f=(a&0xa8)|((!a)<<6)|0x10|parity(a);\
                   } while(0)

#define xora(x) /* logical xor */ do{\
                      a^=(x);\
                      f=(a&0xa8)|((!a)<<6)|parity(a);\
                   } while(0)
#define ora(x) /* logical or */ do{\
                      a|=(x);\
                      f=(a&0xa8)|((!a)<<6)|parity(a);\
                   } while(0)

#define jr		do { int j = (signed char)timed_read_byte(pc); pc += j+1; g_nLineCycle += 4; } while(0)
#define jp		(pc=timed_read_word(pc))

#define call	do { push(pc+2); jp; } while(0)
#define ret		do { pop(pc); } while(0)
#define retn	do { iff1=iff2; ret; } while (0)

// pop 16-bit value
#define pop(var)	do { var = timed_read_word(sp); sp += 2; } while(0)

// push 16-bit value
#define push(val)	do { sp -= 2; timed_write_word(sp,(val)); } while(0)


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// nop
instr(0,4);
endinstr;

// ld bc,nn
instr(1,12);
	bc = timed_read_word(pc);
	pc += 2;
endinstr;

// ld (bc),a
instr(2,8);
	timed_write_byte(bc,a);
endinstr;

// inc bc
instr2(3,8,8);
	bc++;
	g_nLineCycle += 4;
endinstr;


// inc b
instr(4,4);
	inc(b);
endinstr;

// dec b
instr(5,4);
	dec(b);
endinstr;

// ld b,n
instr(6,8);
	b = timed_read_byte(pc);
	pc++;
endinstr;

// rlc a
instr(7,4);
	a=(a<<1)|(a>>7);
	f=(f&0xc4)|(a&0x29);
endinstr;


// ex af,af'
instr(8,4);
	swap(af,alt_af);
endinstr;

// add hl/ix/iy,bc
instr2(9,12,16);
	addhl(b,c);
endinstr;

// ld a,(bc)
instr(10,8);
	a = timed_read_byte(bc);
endinstr;

// dec bc
instr2(11,8,8);
	bc--;
	g_nLineCycle += 4;
endinstr;


// inc c
instr(12,4);
	inc(c);
endinstr;

// dec c
instr(13,4);
	dec(c);
endinstr;

// ld c,n
instr(14,8);
	c = timed_read_byte(pc);
	pc++;
endinstr;

// rrc a
instr(15,4);
	f = (f & 0xc4) | (a & 1);
	a = (a >> 1) | (a << 7);
	f |= a & 0x28;
endinstr;


// djnz e
instr2(16,16,16);
	g_nLineCycle += 4;
	if(--b)
		jr;		// 16 tstates for looping, regardless of screen contention
	else
	{
		MEM_ACCESS(pc);
		pc++;
	}
endinstr;

// ld de,nn
instr(17,12);
	de = timed_read_word(pc);
	pc += 2;
endinstr;

// ld (de),a
instr(18,8);
	timed_write_byte(de,a);
endinstr;

// inc de
instr2(19,8,8);
	de++;
	g_nLineCycle += 4;
endinstr;


// inc d
instr(20,4);
	inc(d);
endinstr;

// dec d
instr(21,4);
	dec(d);
endinstr;

// ld d,n
instr(22,8);
	d = timed_read_byte(pc);
	pc++;
endinstr;

// rla
instr(23,4);
{
	int t = a >> 7;
	a = (a << 1) | (f & 1);
	f = (f & 0xc4) | (a & 0x28) | t;
}
endinstr;


// jr e
instr2(24,12,16);
	jr;
endinstr;

// add hl/ix/iy,de
instr2(25,12,16);
	addhl(d,e);
endinstr;

// ld a,(de)
instr(26,8);
	a = timed_read_byte(de);
endinstr;

// dec de
instr2(27,8,8);
	de--;
	g_nLineCycle += 4;
endinstr;


// inc e
instr(28,4);
	inc(e);
endinstr;

// dec e
instr(29,4);
	dec(e);
endinstr;

// ld e,n
instr(30,8);
	e = timed_read_byte(pc);
	pc++;
endinstr;

// rra
instr(31,4);
{
	int t = a & 1;
	a = (a >> 1) | (f << 7);
	f = (f & 0xc4) | (a & 0x28) | t;
}
endinstr;


// jr nz,e
instr2(32,12,16);
	if (!(f & F_ZERO))
		jr;
	else {
		MEM_ACCESS(pc);
		pc++;
	}
endinstr;

// ld hl,nn
instr(33,12);
	*pHlIxIy = timed_read_word(pc);
	pc += 2;
endinstr;

// ld (nn),hl
instr(34,20);
{
	WORD addr = timed_read_word(pc);
	pc += 2;
	timed_write_word(addr,*pHlIxIy);
}
endinstr;

// inc hl
instr2(35,8,8);
	(*pHlIxIy)++;
	g_nLineCycle += 4;
endinstr;

// inc h
instr(36,4);
	inc(xh);
endinstr;

// dec h
instr(37,4);
	dec(xh);
endinstr;

// ld h,n
instr(38,8);
	xh = timed_read_byte(pc);
	pc++;
endinstr;

// daa
instr(39,4);
{
	BYTE incr=0, carry=cy;

	if ((f & 0x10) || (a & 0x0f) > 9)
		incr=6;

	if ((f & 1) || (a >> 4) > 9)
		incr |= 0x60;

	if (f & 2)
		suba(incr);
	else
	{
		if (a > 0x90 && (a & 15) > 9)
			incr|=0x60;

		adda(incr);
	}

	f = ((f | carry) & 0xfb) | parity(a);
}
endinstr;

// jr z,e
instr2(40,12,16);
	if (f & F_ZERO)
		jr;
	else {
		MEM_ACCESS(pc);
		pc++;
	}
endinstr;

// add hl,hl
instr2(41,12,16);
	addhl(xh, xl);
endinstr;

// ld hl,(nn)
instr(42,20);
{
	WORD addr = timed_read_word(pc);
	*pHlIxIy = timed_read_word(addr);
	pc += 2;
}
endinstr;

// dec hl
instr2(43,8,8);
	(*pHlIxIy)--;
	g_nLineCycle += 4;
endinstr;


// inc l
instr(44,4);
	inc(xl);
endinstr;

// dec l
instr(45,4);
	dec(xl);
endinstr;

// ld l,n
instr(46,8);
	xl = timed_read_byte(pc);
	pc++;
endinstr;

// cpl
instr(47,4);
	a = ~a;
	f = (f & 0xc5) | (a & 0x28) | 0x12;
endinstr;


// jr nc,e
instr2(48,12,16);
	if (!(f & F_CARRY))
		jr;
	else {
		MEM_ACCESS(pc);
		pc++;
	}
endinstr;

// ld sp,nn
instr(49,12);
	sp = timed_read_word(pc);
	pc += 2;
endinstr;

// ld (nn),a
instr(50,16);
{
	WORD addr = timed_read_word(pc);
	pc += 2;
	timed_write_byte(addr,a);
}
endinstr;

// inc sp
instr2(51,8,8);
	sp++;
	g_nLineCycle += 4;
endinstr;


// inc (hl), inc (ix+d), inc (iy+d)
HLinstr(52,12,8);
{
	BYTE t=timed_read_byte(addr);
	inc(t);
	timed_write_byte(addr,t);
}
endinstr;

// dec (hl), dec (ix+d), dec (iy+d)
HLinstr(53,12,8);
{
	BYTE t=timed_read_byte(addr);
	dec(t);
	timed_write_byte(addr,t);
}
endinstr;

// ld (hl),n
HLinstr(54,12,8);
	BYTE t=timed_read_byte(pc);
	timed_write_byte(addr,t);
	pc++;
endinstr;

// scf
instr(55,4);
	f = (f & 0xc4) | 1 | (a & 0x28);
endinstr;


// jr c,e
instr2(56,12,16);
	if (f & F_CARRY)
		jr;
	else {
		MEM_ACCESS(pc);
		pc++;
	}
endinstr;

// add hl,sp
instr2(57,12,16);
	addhl((sp>>8),(sp&0xff));
endinstr;

// ld a,(nn)
instr(58,16);
{
	WORD addr=timed_read_word(pc);
	pc += 2;
	a=timed_read_byte(addr);
}
endinstr;

// dec sp
instr2(59,8,8);
	sp--;
	g_nLineCycle += 4;
endinstr;


// inc a
instr(60,4);
	inc(a);
endinstr;

// dec a
instr(61,4);
	dec(a);
endinstr;

// ld a,n
instr(62,8);
	a=timed_read_byte(pc);
	pc++;
endinstr;

// ccf
instr(63,4);
	f=(f&0xc4)|(cy^1)|(cy<<4)|(a&0x28);
endinstr;


// ld b,b
instr(0x40,4);
endinstr;

// ld b,c
instr(0x41,4);
	b=c;
endinstr;

// ld b,d
instr(0x42,4);
	b=d;
endinstr;

// ld b,e
instr(0x43,4);
	b=e;
endinstr;

// ld b,h
instr(0x44,4);
	b=xh;
endinstr;

// ld b,l
instr(0x45,4);
	b=xl;
endinstr;

// ld b,(hl)
HLinstr(0x46,8,8);
	b = timed_read_byte(addr);
endinstr;

// ld b,a
instr(0x47,4);
	b=a;
endinstr;

// ld c,b
instr(0x48,4);
	c=b;
endinstr;

// ld c,c
instr(0x49,4);
endinstr;

// ld c,d
instr(0x4a,4);
	c=d;
endinstr;

// ld c,e
instr(0x4b,4);
	c=e;
endinstr;

// ld c,h
instr(0x4c,4);
	c=xh;
endinstr;

// ld c,l
instr(0x4d,4);
	c=xl;
endinstr;

// ld c,(hl)
HLinstr(0x4e,8,8);
	c = timed_read_byte(addr);
endinstr;

// ld c,a
instr(0x4f,4);
	c=a;
endinstr;

// ld d,b
instr(0x50,4);
	d=b;
endinstr;

// ld d,c
instr(0x51,4);
	d=c;
endinstr;

// ld d,d
instr(0x52,4);
endinstr;

// ld d,e
instr(0x53,4);
	d=e;
endinstr;

// ld d,h
instr(0x54,4);
	d=xh;
endinstr;

// ld d,l
instr(0x55,4);
	d=xl;
endinstr;

// ld d,(hl)
HLinstr(0x56,8,8);
	d=timed_read_byte(addr);
endinstr;

// ld d,a
instr(0x57,4);
	d=a;
endinstr;

// ld e,b
instr(0x58,4);
	e=b;
endinstr;

// ld e,c
instr(0x59,4);
	e=c;
endinstr;

// ld e,d
instr(0x5a,4);
	e=d;
endinstr;

// ld e,e
instr(0x5b,4);
endinstr;

// ld e,h
instr(0x5c,4);
	e=xh;
endinstr;

// ld e,l
instr(0x5d,4);
	e=xl;
endinstr;

// ld e,(hl)
HLinstr(0x5e,8,8);
	e = timed_read_byte(addr);
endinstr;

// ld e,a
instr(0x5f,4);
	e=a;
endinstr;

// ld h,b
instr(0x60,4);
	xh = b;
endinstr;

// ld h,c
instr(0x61,4);
	xh = c;
endinstr;

// ld h,d
instr(0x62,4);
	xh = d;
endinstr;

// ld h,e
instr(0x63,4);
	xh = e;
endinstr;

// ld h,h
instr(0x64,4);
endinstr;

// ld h,l
instr(0x65,4);
	xh = xl;
endinstr;

// ld h,(hl)
HLinstr(0x66,8,8);
	h = timed_read_byte(addr);
endinstr;

// ld h,a
instr(0x67,4);
	xh = a;
endinstr;

// ld l,b
instr(0x68,4);
	xl = b;
endinstr;

// ld l,c
instr(0x69,4);
	xl = c;
endinstr;

// ld l,d
instr(0x6a,4);
	xl = d;
endinstr;

// ld l,e
instr(0x6b,4);
	xl = e;
endinstr;

// ld l,h
instr(0x6c,4);
	xl = xh;
endinstr;

// ld l,l
instr(0x6d,4);
endinstr;


// ld l,(hl)
HLinstr(0x6e,8,8);
	l=timed_read_byte(addr);
endinstr;

// ld l,a
instr(0x6f,4);
	xl = a;
endinstr;

// ld (hl),b
HLinstr(0x70,8,8);
	timed_write_byte(addr,b);
endinstr;

// ld (hl),c
HLinstr(0x71,8,8);
	timed_write_byte(addr,c);
endinstr;

// ld (hl),d
HLinstr(0x72,8,8);
	timed_write_byte(addr,d);
endinstr;

// ld (hl),e
HLinstr(0x73,8,8);
	timed_write_byte(addr,e);
endinstr;

// ld (hl),h
HLinstr(0x74,8,8);
	timed_write_byte(addr,h);
endinstr;

// ld (hl),l
HLinstr(0x75,8,8);
	timed_write_byte(addr,l);
endinstr;

// halt
instr(0x76,4);
	pc--;	// HALT executes NOPs instructions until the next interrupt
endinstr;

// ld (hl),a , ld (ix+d),a , ld (iy+d),a
HLinstr(0x77,8,8);
	timed_write_byte(addr,a);
endinstr;

// ld a,b
instr(0x78,4);
	a=b;
endinstr;

// ld a,c
instr(0x79,4);
	a=c;
endinstr;

// ld a,d
instr(0x7a,4);
	a=d;
endinstr;

// ld a,e
instr(0x7b,4);
	a=e;
endinstr;

// ld a,h
instr(0x7c,4);
	a=xh;
endinstr;

// ld a,l
instr(0x7d,4);
	a=xl;
endinstr;

// ld a,(hl)
HLinstr(0x7e,8,8);
	a=timed_read_byte(addr);
endinstr;

// ld a,a
instr(0x7f,4);
endinstr;


// add a,b
instr(0x80,4);
	adda(b);
endinstr;

// add a,c
instr(0x81,4);
	adda(c);
endinstr;

// add a,d
instr(0x82,4);
	adda(d);
endinstr;

// add a,e
instr(0x83,4);
	adda(e);
endinstr;

// add a,h
instr(0x84,4);
	adda(xh);
endinstr;

// add a,l
instr(0x85,4);
	adda(xl);
endinstr;

// add a,(hl)
HLinstr(0x86,8,8);
	adda(timed_read_byte(addr));
endinstr;

// add a,a
instr(0x87,4);
	adda(a);
endinstr;

// adc a,b
instr(0x88,4);
	adca(b);
endinstr;

// adc a,c
instr(0x89,4);
	adca(c);
endinstr;

// adc a,d
instr(0x8a,4);
	adca(d);
endinstr;

// adc a,e
instr(0x8b,4);
	adca(e);
endinstr;

// adc a,h
instr(0x8c,4);
	adca(xh);
endinstr;

// adc a,l
instr(0x8d,4);
	adca(xl);
endinstr;

// adc a,(hl)
HLinstr(0x8e,8,8);
	adca(timed_read_byte(addr));
endinstr;

// adc a,a
instr(0x8f,4);
	adca(a);
endinstr;

// sub b
instr(0x90,4);
	suba(b);
endinstr;

// sub c
instr(0x91,4);
	suba(c);
endinstr;

// sub d
instr(0x92,4);
	suba(d);
endinstr;

// sub e
instr(0x93,4);
	suba(e);
endinstr;

// sub h
instr(0x94,4);
	suba(xh);
endinstr;

// sub l
instr(0x95,4);
	suba(xl);
endinstr;

// sub (hl)
HLinstr(0x96,8,8);
	suba(timed_read_byte(addr));
endinstr;

// sub a
instr(0x97,4);
	suba(a);
endinstr;

// sbc a,b
instr(0x98,4);
	sbca(b);
endinstr;

// sbc a,c
instr(0x99,4);
	sbca(c);
endinstr;

// sbc a,d
instr(0x9a,4);
	sbca(d);
endinstr;

// sbc a,e
instr(0x9b,4);
	sbca(e);
endinstr;

// sbc a,h
instr(0x9c,4);
	sbca(xh);
endinstr;

// sbc a,l
instr(0x9d,4);
	sbca(xl);
endinstr;

// sbc a,(hl)
HLinstr(0x9e,8,8);
	sbca(timed_read_byte(addr));
endinstr;

// sbc a,a
instr(0x9f,4);
	sbca(a);
endinstr;

// and b
instr(0xa0,4);
	anda(b);
endinstr;

// and c
instr(0xa1,4);
	anda(c);
endinstr;

// and d
instr(0xa2,4);
	anda(d);
endinstr;

// and e
instr(0xa3,4);
	anda(e);
endinstr;

// and h
instr(0xa4,4);
	anda(xh);
endinstr;

// and l
instr(0xa5,4);
	anda(xl);
endinstr;

// and (hl)
HLinstr(0xa6,8,8);
	anda(timed_read_byte(addr));
endinstr;

// and a
instr(0xa7,4);
	anda(a);
endinstr;

// xor b
instr(0xa8,4);
	xora(b);
endinstr;

// xor c
instr(0xa9,4);
	xora(c);
endinstr;

// xor d
instr(0xaa,4);
	xora(d);
endinstr;

// xor e
instr(0xab,4);
	xora(e);
endinstr;

// xor h
instr(0xac,4);
	xora(xh);
endinstr;

// xor l
instr(0xad,4);
	xora(xl);
endinstr;

// xor (hl)
HLinstr(0xae,8,8);
	xora(timed_read_byte(addr));
endinstr;

// xor a
instr(0xaf,4);
	xora(a);
endinstr;

// or b
instr(0xb0,4);
	ora(b);
endinstr;

// or c
instr(0xb1,4);
	ora(c);
endinstr;

// or d
instr(0xb2,4);
	ora(d);
endinstr;

// or e
instr(0xb3,4);
	ora(e);
endinstr;

// or h
instr(0xb4,4);
	ora(xh);
endinstr;

// or l
instr(0xb5,4);
	ora(xl);
endinstr;

// or (hl)
HLinstr(0xb6,8,8);
	ora(timed_read_byte(addr));
endinstr;

// or a
instr(0xb7,4);
	ora(a);
endinstr;

// cp b
instr(0xb8,4);
	cpa(b);
endinstr;

// cp c
instr(0xb9,4);
	cpa(c);
endinstr;

// cp d
instr(0xba,4);
	cpa(d);
endinstr;

// cp e
instr(0xbb,4);
	cpa(e);
endinstr;

// cp h
instr(0xbc,4);
	cpa(xh);
endinstr;

// cp l
instr(0xbd,4);
	cpa(xl);
endinstr;

// cp (hl)
HLinstr(0xbe,8,8);
	cpa(timed_read_byte(addr));
endinstr;

// cp a
instr(0xbf,4);
	cpa(a);
endinstr;

// ret nz
instr(0xc0,12);
	if(!(f & F_ZERO))
		ret;
	g_nLineCycle += 4;
endinstr;

// pop bc
instr(0xc1,12);
	pop(bc);
endinstr;

//jp nz,nn
instr(0xc2,12);
	if(!(f&F_ZERO))
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

//jp nn
instr(0xc3,12);
	jp;
endinstr;

// call nz,pq
instr(0xc4,20);
	if(!(f & F_ZERO))
		call;
	else
	{
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// push bc
instr2(0xc5,16,24);
	push(bc);
	g_nLineCycle += 4;
endinstr;

// add a,n
instr(0xc6,8);
	adda(timed_read_byte(pc));
	pc++;
endinstr;

// rst 0
instr(0xc7,12);
	push(pc);
	pc=0;
endinstr;

// ret z
instr(0xc8,12);
	if(f & F_ZERO)
		ret;
	g_nLineCycle += 4;
endinstr;

// ret
instr(0xc9,12);
	ret;
endinstr;

// jp z
instr(0xca,12);
	if (f & F_ZERO)
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// [cb prefix]
// Note: The CB prefix timing is included in each CB instruction - No it's not any more!
instr0(0xcb);
#include "CBops.h"
endinstr;

// call z,nn
instr(0xcc,20);
	if (f & F_ZERO)
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// call nn
instr(0xcd,20);
	call;
endinstr;

// adc a,n
instr(0xce,8);
	adca(timed_read_byte(pc));
	pc++;
endinstr;

// rst 8
instr(0xcf,12);
	push(pc);
	pc = 8;
endinstr;

// ret nc
instr(0xd0,12);
	if(!cy)
		ret;
	g_nLineCycle += 4;
endinstr;

// pop de
instr(0xd1,12);
	pop(de);
endinstr;

// jp nc,nn
instr(0xd2,12);
	if(!cy)
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// out (n),a
instr0(0xd3);
	BYTE bPortLow = timed_read_byte(pc);
	PORT_ACCESS(bPortLow);
	out_byte((a<<8) + bPortLow,a);
	pc++;
endinstr;

// call nc,nn
instr(0xd4,20);
	if(!cy)
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// push de
instr2(0xd5,16,24);
	push(de);
	g_nLineCycle += 4;
endinstr;

// sub n
instr(0xd6,8);
	suba(timed_read_byte(pc));
	pc++;
endinstr;

// rst 16
instr(0xd7,12);
	push(pc);
	pc = 16;
endinstr;

// ret c
instr(0xd8,12);
	if(cy)
		ret;
	g_nLineCycle += 4;
endinstr;

// exx
instr(0xd9,4);
	swap(bc,alt_bc);
	swap(de,alt_de);
	swap(hl,alt_hl);
endinstr;

// jp c,nn
instr(0xda,12);
	if(cy)
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// in a,(n)
instr0(0xdb);
	BYTE bPortLow = timed_read_byte(pc);
	PORT_ACCESS(bPortLow);
	a = in_byte((a<<8)+bPortLow);
	pc++;
endinstr;

// call c,nn
instr(0xdc,20);
	if(cy)
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// [ix prefix]
instr(0xdd,4);
	pNewHlIxIy = &ix;
endinstr;

// sbc a,n
instr(0xde,8);
	sbca(timed_read_byte(pc));
	pc++;
endinstr;

// rst 24
instr(0xdf,12);
	push(pc);
	pc = 24;
endinstr;

// ret po
instr(0xe0,12);
	if(!(f & F_PARITY))
		ret;
	g_nLineCycle += 4;
endinstr;

// pop hl/ix/iy
instr(0xe1,12);
	pop(*pHlIxIy);
endinstr;

// jp po,nn
instr(0xe2,12);
	if(!(f&F_PARITY))
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// ex (sp),hl
instr(0xe3,20);
	WORD t = timed_read_word(sp);
	timed_write_word(sp,*pHlIxIy);
	*pHlIxIy = t;
	g_nLineCycle += 4;
endinstr;

// call po
instr(0xe4,20);
	if (!(f & F_PARITY))
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// push hl
instr2(0xe5,16,24);
	push(*pHlIxIy);
	g_nLineCycle += 4;
endinstr;

// and n
instr(0xe6,8);
	anda(timed_read_byte(pc));
	pc++;
endinstr;

// rst 32
instr(0xe7,12);
	push(pc);
	pc = 32;
endinstr;

// ret pe
instr(0xe8,12);
	if (f&4)
		ret;
	g_nLineCycle += 4;
endinstr;


// jp (hl), jp (ix), jp (iy)
instr(0xe9,4);
	pc = *pHlIxIy;
endinstr;

// jp pe,nn
instr(0xea,12);
	if (f & F_PARITY)
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// ex de,hl
instr(0xeb,4);
	swap(de,hl);
endinstr;

// call pe,nn
instr(0xec,20);
	if (f & F_PARITY)
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;



// [ed prefix]
// Note: The ED prefix timing is included in each ED instruction (it can't be repeated like DD/FD anyway). Not any more it aint!
instr0(0xed);
#include "EDops.h"
endinstr;

// xor n
instr(0xee,8);
	xora(timed_read_byte(pc));
	pc++;
endinstr;

// rst 40
instr(0xef,12);
	push(pc);
	pc = 40;
endinstr;

// ret p
instr(0xf0,12);
	if (!(f & F_NEG))
		ret;
	g_nLineCycle += 4;
endinstr;


// pop af
instr(0xf1,12);
	pop(af);
endinstr;

// jp p,nn
instr(0xf2,12);
	if (!(f & F_NEG))
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// di
instr(0xf3,4);
	iff1 = iff2 = 0;
endinstr;

// call p,
instr(0xf4,20);
	if (!(f & F_NEG))
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// push af
instr2(0xf5,16,24);
	push(af);
	g_nLineCycle += 4;
endinstr;

// or n
instr(0xf6,8);
	ora(timed_read_byte(pc));
	pc++;
endinstr;

// rst 48
instr(0xf7,12);
	push(pc);
	pc = 48;
endinstr;



// ret m
instr(0xf8,12);
	if(f&0x80)
		ret;
	g_nLineCycle += 4;
endinstr;

// ld sp,hl
instr2(0xf9,8,8);
	sp = *pHlIxIy;
	g_nLineCycle += 4;
endinstr;

// jp m,nn
instr(0xfa,12);
	if (f & F_NEG)
		jp;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// ei
instr(0xfb,4);
	// According to Z80 specs, interrupts are not enabled until AFTER the next instruction
	// Only delay EI if interrupts are currently disabled
	iff1 = iff2 = 1;
endinstr;


// call m,nn
instr(0xfc,20);
	if(f & F_NEG)
		call;
	else {
		MEM_ACCESS(pc);
		MEM_ACCESS(pc + 1);
		pc += 2;
	}
endinstr;

// [iy prefix]
instr(0xfd,4);
	pNewHlIxIy = &iy;
endinstr;

// cp n
instr(0xfe,8);
	cpa(timed_read_byte(pc));
	pc++;
endinstr;

// rst 56
instr(0xff,12);
	push(pc);
	pc = 56;
endinstr;

#ifdef _DEBUG
// Nothing should reach here!
default:
	DebugBreak();
#endif
