#include "stdafx.h"

#include "SAM.h"
#include "Video.h"
#include "Util.h"
#include "Options.h"
#include "IO.h"

/*
The following code is what you're after... It will convert any R(0 to 255)
G(0 to 255) B(0 to 255) value into 16Bit PixelFormat matching the
Information of any card video surface format  returned by the GetPixelFormat
be that its 5-5-5, 5-6-5, 4-4-4-4, 5-5-5-1, 1-5-5-5 or any other that is not
listed here and it doesn't care if it RGB, BGR or any other order the video
card throws at it. Sounds like a programmers dream come true... its simplier
than you think, it done by having a look up table, that calculate the RGB
from the GetPixelFormat info.

// Declare the following globally or make a class ...whatever you fancy
unsigned short int* redLUT;
unsigned short int* greenLUT;
unsigned short int* blueLUT;

unsigned short int globalColourTable[256 * 3];

unsigned short int rMask;
unsigned short int gMask;
unsigned short int bMask;


make a routine and call it something like make16BitTable, whatever you fancy
and at the start of the program after you've initialized the video mode, run
this routine once to create the lookup table.

	redLUT = globalColourTable;     // Get a pointer to each lookup table
	greenLUT = globalColourTable + 256;
	blueLUT = globalColourTable + 512;

	pixelFormat = GetPixelFormat(........

	rMask = pixelFormat.dwRBitMask;
	gMask = pixelFormat.dwGBitMask;
	bMask = pixelFormat.dwBBitMask;

	// Create the lookup table
	for (__int64 palTable = 0; palTable < 256; palTable++)
	{
		redLUT[palTable] = unsigned short int(((__int64(rMask) * palTable) >> 8) & rMask);
		greenLUT[palTable] = unsigned short int(((__int64(gMask * palTable)) >> 8) & gMask);
		blueLUT[palTable] = unsigned short int(((__int64(bMask) * palTable) >> 8) & bMask);
	}


Now....

to convert red in 24bits format which is 255,0,0 to 16Bits format, use the
following formula

unsigned short int Bit16Red = redLUT[255] | greenLUT[0] | blueLUT[0];

and it will return red in 16bit format, it as simple as that.


make a macro to simplify things

#define RGB16(r, g, b) (redLUT[r] | greenLUT[g] | blueLUT[b])

unsigned short int 16BitRed = RGB16(255,0,0);


Someone mentioned a 6-6-4 format, I'm intrested to know which video card
handles that format, just out of interest like. Any offers?
*/


extern bool init_display_depth ();
extern void ResizeWindow ();

DWORD aulPalette[NCOLOURS];		// 128 SAM colours

namespace Video
{

// function to initialize DirectDraw in windowed mode
bool Init ()
{
	// Make sure any existing setup is terminated before we set up again
	Exit();

	BOOL fPalette = false;

	for (int i = 0; i < NCOLOURS; i++)
	{
		// Convert from SAM palette position to 3-bit RGB
		DWORD dwBlue  = ((i&0x01) << 1| ((i&0x10) >> 2) | ((i&0x08) >> 3));
		DWORD dwRed   = ((i&0x02)     | ((i&0x20) >> 3) | ((i&0x08) >> 3));
		DWORD dwGreen = ((i&0x04) >> 1| ((i&0x40) >> 4) | ((i&0x08) >> 3));

		// Extend the 3-bit values to 8-bit, preserving black as black
		dwBlue = dwBlue ? ((dwBlue+1) << 5) -1 : 0;
		dwRed = dwRed ? ((dwRed+1) << 5) -1 : 0;
		dwGreen = dwGreen ? ((dwGreen+1) << 5) -1 : 0;

		// Write the palette components, leaving the first 10 entries for menu colours etc.
//		pal[i+10].peRed = static_cast<BYTE>(dwRed);
//		pal[i+10].peGreen = static_cast<BYTE>(dwGreen);
//		pal[i+10].peBlue = static_cast<BYTE>(dwBlue);
//		pal[i+10].peFlags = PC_NOCOLLAPSE;

		UINT uBPP = 16;

		// In 8 bit mode use offset palette positions to allow for system colours in the first 10
		if (fPalette)
			aulPalette[i] = i+10;

		// In 5-5-5 16-bit mode use 5 bit versions of each colour
		else if (uBPP == 16/* && (desc.ddpfPixelFormat.dwGBitMask == 0x03e0)*/)	// 5-5-5 format
			aulPalette[i] = ((dwRed>>3)<<11) | ((dwGreen>>3)<<5) | ((dwBlue>>3)<<0);

		// In 5-6-5 16-bit mode use 5 bit versions of red and blue, but 6 bit for green
//		else if (uBPP == 16 && (desc.ddpfPixelFormat.dwGBitMask == 0x07e0))
//			aulPalette[i] = ((ulRed>>3)<<11) | ((ulGreen>>2)<<5) | ((ulBlue>>3)<<0);

		else if (uBPP == 24)
			aulPalette[i] = (dwBlue<<16) | (dwGreen<<8) | dwRed;

		// In 32-bit mode use the full RGB values
		else
			aulPalette[i] = (dwRed<<16) | (dwGreen<<8) | dwBlue;
	}

	// Because the pixel format may have changed, we need to refresh the SAM CLUT pixel values
	for (i = 0 ; i < 16 ; i++)
		clut[i] = aulPalette[clutval[i]];

	bool fRet = init_display_depth();
	ResizeWindow();

	TRACE("Leaving Video::Init()\n");
    return fRet;
}

// Cleanup DirectX by releasing all the interfaces we have
void Exit()
{
	TRACE("Video::Exit()\n");
	TRACE("Leaving Video::Exit()\n");
}

void UpdatePalette ()
{
}

void WaitVBlank ()
{
//	pdd->WaitForVerticalBlank(DDWAITVB_BLOCKEND, 0);
}

}
