//	Notes:
//		Very much a work in progress...  lots of code fragments from MSDN and
//		the web, with info on the various ways to do it.
//
//		I'm still working on the NT/W2K version, which does work well when my
//		kernel-mode driver is in place and doing it's stuff (still unfinished
//		for normal use - to come very soon).
//
//		The Win9x version used to work, just slowly, but since working on the
//		WinNT/W2K version it's pretty broken.  Looks like the Win9x version will
//		need some sort of caching to speed it up, tho the disk change detection
//		mechanism has still not been worked out.  I want to avoid reading from
//		the disk when it could be cached, but some disk operation needs to be
//		done to get the disk change status.  Maybe a seek or something will
//		work - to be done after the WinNT/W2K version.
//
//		I'm using for the INT13 method on Win9x in the hope that it'll cover
//		everything that's needed, as that'd be the DOS way of doing it.


#include "stdafx.h"
#include "winioctl.h"

#include "Floppy.h"
#include "CDisk.h"
#include "UI.h"
#include "Util.h"


#define IOCTL_DISK_SET_DRIVE_GEOMETRY   CTL_CODE(IOCTL_DISK_BASE, 0x0849, METHOD_BUFFERED, FILE_READ_DATA|FILE_WRITE_DATA)

#define NT_DRIVER_NAME		"SAMDISK"
#define NT_DRIVER_DESC		"SAM Coup Disk Filter"


// DeviceIoControl registers structure for DOS-type calls
typedef struct _DIOC_REGISTERS
{
    DWORD reg_EBX;
    DWORD reg_EDX;
    DWORD reg_ECX;
    DWORD reg_EAX;
    DWORD reg_EDI;
    DWORD reg_ESI;
    DWORD reg_Flags;
}
DIOC_REGISTERS, *PDIOC_REGISTERS;


// DeviceIoControl codes for various DOS-type functions
#define VWIN32_DIOC_DOS_IOCTL		1
#define VWIN32_DIOC_DOS_INT25		2
#define VWIN32_DIOC_DOS_INT26		3
	#define VWIN32_DIOC_DOS_INT13		4
#define VWIN32_DIOC_DOS_DRIVEINFO	6

////////////////////////////////////////////////////////////////////////////////


bool IsWinNT ()
{
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof osvi;

	GetVersionEx(&osvi);

	return (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT);
}

/*static*/ bool CFloppyStream::IsRecognised (const char* pcszStream_)
{
	return (GetDriveType(pcszStream_) == DRIVE_REMOVABLE);
}

namespace Floppy
{

bool Init ()
{
	CFloppyStream::LoadDriver();
	return true;
}

void Exit ()
{
	CFloppyStream::UnloadDriver();
}

}	// namespace Floppy



/*static*/ bool CFloppyStream::LoadDriver ()
{
	bool fRet = false;
	SC_HANDLE hManager, hService;
	char szPath[_MAX_PATH], *pszFile;

	// Form the full path of the driver in the same location that SimCoupe.exe is running from
	if (!SearchPath(NULL, NT_DRIVER_NAME ".SYS", NULL, sizeof szPath, szPath, &pszFile))
		TRACE("!!! Can't find %s driver file!\n", GetLastError());

	// Open the with the Service Control Manager - requires administrative NT/W2K rights to do what we need!
	else if (!(hManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS)))
		TRACE("!!! Failed to open service control manager (%#08lx)\n", GetLastError());

	// Open the existing service, create it if it's not already there
	else
	{
		if (!(hService = OpenService(hManager, NT_DRIVER_NAME, SERVICE_ALL_ACCESS)) &&
			!(hService = CreateService(hManager, NT_DRIVER_NAME, NT_DRIVER_DESC, SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER,
							SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL, szPath, NULL, NULL, NULL, NULL, NULL)))
			TRACE("!!! Failed to open/create %s service (%#08lx)\n", NT_DRIVER_NAME, GetLastError());

		else if (!StartService(hService, 0, NULL) && (GetLastError() != ERROR_SERVICE_ALREADY_RUNNING))
			TRACE("!!! Failed to start %s service (%#08lx)\n", NT_DRIVER_NAME, GetLastError());

		else
		{
			// Done with the service
			fRet = true;
			CloseServiceHandle(hService);
		}

		// Done with the Service Control Manager
		CloseServiceHandle(hManager);
	}

	// Return true if the driver is ready to use
	return fRet;
}

/*static*/ bool CFloppyStream::UnloadDriver ()
{
	bool fRet = false;
	SC_HANDLE hManager, hService;

	// Open the with the Service Control Manager - requires administrative NT/W2K rights to do what we need!
	if (!(hManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS)))
		TRACE("!!! Failed to open service control manager (%#08lx)\n", GetLastError());
	else
	{
		SERVICE_STATUS ss;

		// Open the existing service, create it if it's not already there
		if (!(hService = OpenService(hManager, NT_DRIVER_NAME, SERVICE_ALL_ACCESS)) &&
			!(hService = CreateService(hManager, NT_DRIVER_NAME, NT_DRIVER_DESC, SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER,
							SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL, "P:\\src\\SimCoupe\\samdisk.sys", NULL, NULL, NULL, NULL, NULL)))
			TRACE("!!! Failed to open/create %s service (%#08lx)\n", NT_DRIVER_NAME, GetLastError());

		else if (!ControlService(hService, SERVICE_CONTROL_STOP, &ss) && (GetLastError() != ERROR_SERVICE_NOT_ACTIVE))
			TRACE("!!! Failed to stop %s service (%#08lx)\n", NT_DRIVER_NAME, GetLastError());

		else if (!DeleteService(hService))
			TRACE("!!! Failed to delete %s service (%#08lx)\n", NT_DRIVER_NAME, GetLastError());

		else
		{
			// Done with the service
			fRet = true;
			CloseServiceHandle(hService);
		}

		// Done with the Service Control Manager
		CloseServiceHandle(hManager);
	}

	// Return true if the driver is ready to use
	return fRet;
}





/*
	HANDLE hDevice = CreateFile("\\\\.\\VWIN32", 0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, NULL);

	BYTE* pb = new BYTE[102400];
	memset(pb, 0, 102400);

	for (int i = 0 ; i < 4 ; i++)
	{
		DIOC_REGISTERS regs;
		regs.reg_EAX = 0x0201;       // Read sectors, 10 sectors
		regs.reg_EBX = (DWORD)pb;	// 
		regs.reg_ECX = 0x0001;		// cyl 0, sector 1
		regs.reg_EDX = 0x0000;		// head 0, A:
		regs.reg_Flags = 0x0001;     // assume error (carry flag is set) 

		if (!DIOC_Int13(&reg) || (reg.reg_Flags & 0x0001))
		{
			TRACE("Error reading sectors!\n");	// error if carry flag is set

			reg.reg_EAX = 0x0000;       // Reset disk, <none>
			reg.reg_EDX = 0x0000;       // <none>, A:

			if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
			{
				TRACE("Error resetting drive!\n");
				break;
			}
		}
		else
			TRACE("Read %d successful\n");
	}

	delete pb;
	CloseHandle(hDevice);

	return false;	//(GetDriveType(pcszStream_) == DRIVE_REMOVABLE);
}
*/

/*
	{
		m_hDevice = CreateFile("\\\\.\\VWIN32", GENERIC_READ | (fReadOnly_ ? 0 : GENERIC_WRITE),
									0,	NULL, OPEN_EXISTING, FILE_FLAG_DELETE_ON_CLOSE, NULL);

		if (m_hDevice != INVALID_HANDLE_VALUE)
			return new CFloppyStream(hDevice, pcszStream_, fReadOnly_);
	}
	else
*/
















CFloppyStream::CFloppyStream (const char* pcszDrive_, bool fReadOnly_)
	: CStream(pcszDrive_, fReadOnly_), m_hDevice(INVALID_HANDLE_VALUE)
{
	if (IsWinNT())
	{
		// Ensure the device driver is loaded
		char szDevice[32] = "\\\\.\\";
		lstrcat(szDevice, pcszDrive_);

		if ((m_hDevice = CreateFile(szDevice, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
			UI::ShowMessage(msgWarning, "Failed to open floppy device!");
		else
		{
			// This is what we want the disk to look like
			DISK_GEOMETRY dg = { { 80 }, F3_720_512, 2, 10, 512 };

			DWORD dwRet;
			if (DeviceIoControl(m_hDevice, IOCTL_DISK_SET_DRIVE_GEOMETRY, &dg, sizeof dg, NULL, 0, &dwRet, NULL))
				TRACE("New Geometry set: C=%ld, H=%ld, S=%ld\n", *(DWORD*)&dg.Cylinders, dg.TracksPerCylinder, dg.SectorsPerTrack);
			else
			{
				UI::ShowMessage(msgWarning, "SAMDISK driver couldn't be loaded, direct access disabled!");
				CloseHandle(m_hDevice);
				m_hDevice = INVALID_HANDLE_VALUE;
			}
		}
	}
/*
	else
	{
		m_hDevice = CreateFile("\\\\.\\VWIN32", 0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, NULL);

		Reset();

		// Check whether the drive supports the change-line, and remember for later use
		DIOC_REGISTERS regs;
		regs.reg_EAX = 0x1500;       // Get disk type, <none>
		regs.reg_EDX = 0x0000;		// <none>, A:
		regs.reg_Flags = 0x0001;     // assume error (carry flag is set)
		m_fChangeSupported = (DIOC_Int13(&regs) && !(regs.reg_Flags & 0x0001) && ((regs.reg_EAX & 0xff00) == 0x0200));

		Lock();
	}
*/
}


void CFloppyStream::Close ()
{
	if (IsWinNT())
	{
		if (m_hDevice && (m_hDevice!= INVALID_HANDLE_VALUE))
			CloseHandle(m_hDevice);
	}
/*
	else
	{
		if (m_hDevice != INVALID_HANDLE_VALUE)
		{
//			Unlock();
			CloseHandle(m_hDevice);
			m_hDevice = INVALID_HANDLE_VALUE;
		}
	}
*/
}


BYTE CFloppyStream::Read (int nSide_, int nTrack_, int nSector_, BYTE* pbData_, UINT* puSize_)
{
	if (IsWinNT())
	{
		long lPos = (nSide_ + 2 * nTrack_) * (10 * 512) + ((nSector_-1) * 512);

		if (SetFilePointer(m_hDevice, lPos, NULL, FILE_BEGIN) == static_cast<DWORD>(lPos))
		{
//			TRACE("Reading sector from %d:%d:%d\n", nSide_, nTrack_, nSector_);

			DWORD dwRead = 0;
			if (ReadFile(m_hDevice, pbData_, *puSize_ = 512, &dwRead, NULL) && (dwRead == 512))
				return 0;
			else
				TRACE("!!! Failed to read side %d, track %d (%#08lx)\n", nSide_, nTrack_, GetLastError());
		}
		else
			TRACE("!!! Failed to seek to side %d, track %d (%#08lx)\n", nSide_, nTrack_, GetLastError());

		*puSize_ = 0;
		return RECORD_NOT_FOUND;
	}

	*puSize_ = 0;
	return RECORD_NOT_FOUND;
}


BYTE CFloppyStream::Write (int nSide_, int nTrack_, int nSector_, BYTE* pbData_, UINT* puSize_)
{
	if (IsWinNT())
	{
		long lPos = (nSide_ + 2 * nTrack_) * (10 * 512) + ((nSector_-1) * 512);

		if (SetFilePointer(m_hDevice, lPos, NULL, FILE_BEGIN) == static_cast<DWORD>(lPos))
		{
//			TRACE("Writing sector to %d:%d:%d\n", nSide_, nTrack_, nSector_);

			DWORD dwWritten = 0;
			if (WriteFile(m_hDevice, pbData_, *puSize_ = 512, &dwWritten, NULL) && (dwWritten == 512))
				return 0;
			else
				TRACE("!!! Failed to write side %d, track %d (%#08lx)\n", nSide_, nTrack_, GetLastError());
		}
		else
			TRACE("!!! Failed to seek to side %d, track %d (%#08lx)\n", nSide_, nTrack_, GetLastError());

	}

	*puSize_ = 0;
	return RECORD_NOT_FOUND;
}




/*
bool CFloppyStream::DIOC_Int13 (DIOC_REGISTERS* pRegs_)
{
	DWORD dwRet;
	return (DeviceIoControl(m_hDevice, VWIN32_DIOC_DOS_INT13, pRegs_, sizeof *pRegs_, pRegs_, sizeof *pRegs_, &dwRet, NULL) == TRUE);
}

bool CFloppyStream::DIOC_Int21 (DIOC_REGISTERS* pRegs_)
{
	DWORD dwRet;
	return (DeviceIoControl(m_hDevice, VWIN32_DIOC_DOS_IOCTL, pRegs_, sizeof *pRegs_, pRegs_, sizeof *pRegs_, &dwRet, NULL) == TRUE);
}


bool CFloppyStream::CheckChange ()
{
	DIOC_REGISTERS regs;
	regs.reg_EAX = 0x1600;       // Get disk type, <none>
	regs.reg_EDX = 0x0000;		// <none>, A:
	regs.reg_Flags = 0x0000;

	bool f = DIOC_Int13(&regs);
	TRACE("CheckChange()  DIOC=%d, Carry=%d, AH=%#02x\n", f, regs.reg_Flags & 0x0001, (regs.reg_EAX >> 8) & 0xff);
	return (f && (regs.reg_Flags & 0x0001));
}

bool CFloppyStream::Lock ()
{
	DIOC_REGISTERS regs;
	regs.reg_EAX = 0x440d;       // Get disk type, <none>
	regs.reg_EBX = 0x0100;
	regs.reg_ECX = 0x084b;
	regs.reg_EDX = 0x0002;
	regs.reg_Flags = 0x0001;     // assume error (carry flag is set)

	bool fRet = (DIOC_Int21(&regs) && !(regs.reg_Flags & 0x0001));
	if (fRet)
		TRACE("Locked ok\n");
	else
		TRACE("!!! Lock failed: %#02x\n", regs.reg_EAX & 0xffff);

	return fRet;
}

bool CFloppyStream::Unlock ()
{
	DIOC_REGISTERS regs;
	regs.reg_EAX = 0x440d;       // Get disk type, <none>
	regs.reg_EBX = 0x0000;
	regs.reg_ECX = 0x086b;

	bool fRet = (DIOC_Int21(&regs) && !(regs.reg_Flags & 0x0001));
	regs.reg_Flags = 0x0001;     // assume error (carry flag is set)
	if (fRet)
		TRACE("Unlocked ok\n");
	else
		TRACE("!!! Unlock failed: %#02x\n", regs.reg_EAX & 0xffff);

	return fRet;
}

bool CFloppyStream::Reset ()
{
	DIOC_REGISTERS regs;
	regs.reg_EAX = 0x0000;       // Reset disk, <none>
	regs.reg_EDX = 0x0000;       // <none>, A:

	bool fRet = (!DIOC_Int13(&regs) || !(regs.reg_Flags & 0x0001));
	fRet ? TRACE("Drive reset\n") : TRACE("!!! Failed to reset drive\n", (regs.reg_EAX >> 8) & 0xff);
	return fRet;
}
*/



/*
BYTE CFloppyStream::Read (int nSide_, int nTrack_, int nSector_, BYTE* pbData_, UINT* puSize_)
{
	DISK_GEOMETRY dg;
	DWORD dwRet = 0;
	if (DeviceIoControl(m_hDevice, IOCTL_DISK_GET_DRIVE_GEOMETRY, NULL, 0, &dg, sizeof dg, &dwRet, NULL))
		TRACE("Floppy Read: C=%ld, H=%ld, S=%ld\n", *(DWORD*)&dg.Cylinders, dg.TracksPerCylinder, dg.SectorsPerTrack);

	if (m_afCached[nSide_][nTrack_])
	{
		memcpy(pbData_, m_abCached[nSide_][nTrack_][nSector_-1], *puSize_ = sizeof m_abCached[nSide_][nTrack_][nSector_-1]);
		return true;
	}

	if (ReadFile(m_hDevice, m_abCached[nSide_][nTrack_][nSector_-1], 512, &dwRead, NULL) && (dwRead == 512))
	{
		m_afCached[nSide_][nTrack_] = true;
		memcpy(pbData_, m_abCached[nSide_][nTrack_][nSector_-1], *puSize_ = sizeof m_abCached[nSide_][nTrack_][nSector_-1]);
		return true;
	}


//	Lock();

	for (int nRetry = 0 ; nRetry < 3 ; nRetry++)
	{
		memset(m_abCached[nSide_][nTrack_], 0xcd, sizeof m_abCached[nSide_][nTrack_]);

		DIOC_REGISTERS regs;
		regs.reg_EAX = 0x020a;// | (m_afCached[nSide_][nTrack_] ? 0x01 : 0x0a);		// Read sectors, 1 sector
		regs.reg_EBX = (DWORD)m_abCached[nSide_][nTrack_];
		regs.reg_ECX  = (nTrack_ << 8) | 1;
		regs.reg_EDX  = (nSide_ << 8) | 0x00;				// drive A
		regs.reg_Flags = 0x0001;	// assume error (carry flag is set) 

		if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
		{
			TRACE("Error reading sectors!  %#04x\n", regs.reg_EAX & 0xffff);	// error if carry flag is set

			if ((regs.reg_EAX & 0xff00) == 0x0600)
				memset(m_afCached, 0, sizeof m_afCached);

			regs.reg_EAX = 0x0000;       // Reset disk, <none>
			regs.reg_EDX = 0x0000;       // <none>, A:

			if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
			{
				TRACE("Error resetting drive!\n");
				break;
			}
		}
		else
		{
			TRACE("Read successful: %#04x\n", regs.reg_EAX);
			m_afCached[nSide_][nTrack_] = true;
			memcpy(pbData_, m_abCached[nSide_][nTrack_][nSector_-1], *puSize_ = sizeof m_abCached[nSide_][nTrack_][nSector_]);
			break;

//			CheckChange();

			regs.reg_EAX = 0x0000;
			regs.reg_EDX = 0x0000;		// <none>, A:
			regs.reg_Flags = 0x0001;     // assume error (carry flag is set) 

//			if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
//				TRACE("Error reading status: %d\n", regs.reg_EAX & 0xffff);
//			else
//				TRACE("Status: %d\n", regs.reg_EAX & 0xffff);
		}
	}

//	Unlock();
}


LONG CFloppyStream::Read (void* pvBuffer_, LONG lLen_)
{
	DIOC_REGISTERS regs;

	BYTE* pb = new BYTE[102400];
	memset(pb, 0, 102400);

	int nFirst = m_dwPos / (10*512), nLast = lLen_ / (10*512);
	for (int i = nFirst ; i <= nLast ; i++)
	{
	}

	for (int nRetry = 0 ; nRetry < 4 ; nRetry++)
	{
		regs.reg_EAX = 0x020a;		// Read sectors, 1 sector
		regs.reg_EBX = (DWORD)pb;	// 
		regs.reg_ECX = 0x0001;		// cyl 0, sector 1
		regs.reg_EDX = 0x0000;		// head 0, A:
		regs.reg_Flags = 0x0001;	// assume error (carry flag is set) 

		if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
		{
			TRACE("Error reading sectors!  %#04x\n", regs.reg_EAX & 0xffff);	// error if carry flag is set

			regs.reg_EAX = 0x0000;       // Reset disk, <none>
			regs.reg_EDX = 0x0000;       // <none>, A:

			if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
			{
				TRACE("Error resetting drive!\n");
				break;
			}
		}
		else
		{
			TRACE("Read successful: %#04x\n", regs.reg_EAX);

			CheckChange();

			regs.reg_EAX = 0x0000;
			regs.reg_EDX = 0x0000;		// <none>, A:
			regs.reg_Flags = 0x0001;     // assume error (carry flag is set) 

			if (!DIOC_Int13(&regs) || (regs.reg_Flags & 0x0001))
				TRACE("Error reading status: %d\n", regs.reg_EAX & 0xffff);
			else
				TRACE("Status: %d\n", regs.reg_EAX & 0xffff);
		}
	}

	delete pb;


	return 0;
}

LONG CFloppyStream::Write (void* pvBuffer_, LONG lLen_)
{
	return 0;
}
*/


/*
Q174569

Windows 95 OEM Service Release 2 has a bug that affects Int 21h function 440Dh minor codes 61h and 41h only when called
through DeviceIoControl. 



RESOLUTION
There are two ways to work around this bug: 

1. Use DeviceIoControl with VWIN32_DIOC_DOS_INT25 and 

   VWIN32_DIOC_DOS_INT26 to issue Absolute Disk Read (Int 25h) and
   Absolute Disk Write (Int 26h) respectively. This method works
   for FAT12 and FAT16 volumes. This method is compatible with the
   retail release version of Windows 95, but will not work on
   FAT32 volumes.


2. Use DeviceIoControl with VWIN32_DIOC_DOS_DRIVEINFO to issue 
   Ext Absolute Disk Read & Write (Int 21h function 7305h). This
   method works for FAT12, FAT16, and FAT32 volumes, but is not
   backward compatible with the retail release version of
   Windows 95.

*/

/*

	// http://msdn.microsoft.com/library/psdk/win95/excluse_7smj.htm
	// Applications should perform direct disk write operations only in either a level 0 or 3 lock. 

		http://msdn.microsoft.com/library/psdk/win95/95func_9lm0.htm
		Locks the logical volume. 

		mov ax, 440Dh        ; generic IOCTL
		mov bh, LockLevel    ; see below
		mov bl, DriveNum     ; see below
		mov ch, 08h          ; device category (must be 08h)
		mov cl, 4Ah          ; Lock Logical Volume
		mov dx, Permissions  ; see below
		int 21h
*/


/*

#define VWIN32_DIOC_DOS_IOCTL     1
#define VWIN32_DIOC_DOS_INT25     2
#define VWIN32_DIOC_DOS_INT26     3
#define VWIN32_DIOC_DOS_DRIVEINFO 6

typedef struct _DIOC_REGISTERS {
    DWORD reg_EBX;
    DWORD reg_EDX;
    DWORD reg_ECX;
    DWORD reg_EAX;
    DWORD reg_EDI;
    DWORD reg_ESI;
    DWORD reg_Flags;
} DIOC_REGISTERS, *PDIOC_REGISTERS;

#define CARRY_FLAG 1

#pragma pack(1)
typedef struct _DISKIO {
   DWORD  dwStartSector;   // starting logical sector number
   WORD   wSectors;        // number of sectors
   DWORD  dwBuffer;        // address of read/write buffer
} DISKIO, * PDISKIO;
#pragma pack()

BOOL ReadLogicalSectors (HANDLE hDev,
                         BYTE   bDrive,
                         DWORD  dwStartSector,
                         WORD   wSectors,
                         LPBYTE lpSectBuff)
{
   BOOL           fResult;
   DWORD          cb;
   DIOC_REGISTERS reg = {0};
   DISKIO         dio = {0};

   dio.dwStartSector = dwStartSector;
   dio.wSectors      = wSectors;
   dio.dwBuffer      = (DWORD)lpSectBuff;

   reg.reg_EAX = bDrive - 1;    // Int 25h drive numbers are 0-based.
   reg.reg_EBX = (DWORD)&dio;
   reg.reg_ECX = 0xFFFF;        // use DISKIO struct

   fResult = DeviceIoControl(hDev, VWIN32_DIOC_DOS_INT25,
                             &reg, sizeof(reg),
                             &reg, sizeof(reg), &cb, 0);

   // Determine if the DeviceIoControl call and the read succeeded.
   fResult = fResult && !(reg.reg_Flags & CARRY_FLAG);

   return fResult;
}


BOOL WriteLogicalSectors (HANDLE hDev,
                          BYTE   bDrive,
                          DWORD  dwStartSector,
                          WORD   wSectors,
                          LPBYTE lpSectBuff)
{
   BOOL           fResult;
   DWORD          cb;
   DIOC_REGISTERS reg = {0};
   DISKIO         dio = {0};

   dio.dwStartSector = dwStartSector;
   dio.wSectors      = wSectors;
   dio.dwBuffer      = (DWORD)lpSectBuff;

   reg.reg_EAX = bDrive - 1;    // Int 26h drive numbers are 0-based.
   reg.reg_EBX = (DWORD)&dio;
   reg.reg_ECX = 0xFFFF;        // use DISKIO struct

   fResult = DeviceIoControl(hDev, VWIN32_DIOC_DOS_INT26,
                             &reg, sizeof(reg),
                             &reg, sizeof(reg), &cb, 0);

   // Determine if the DeviceIoControl call and the write succeeded.
   fResult = fResult && !(reg.reg_Flags & CARRY_FLAG);

   return fResult;
}

BOOL NewReadSectors (HANDLE hDev, BYTE   bDrive, DWORD  dwStartSector, WORD   wSectors, LPBYTE lpSectBuff)
{
  BOOL           fResult;
  DWORD          cb;
  DIOC_REGISTERS reg = {0};
  DISKIO         dio;

  dio.dwStartSector = dwStartSector;
  dio.wSectors      = wSectors;
  dio.dwBuffer      = (DWORD)lpSectBuff;

  reg.reg_EAX = 0x7305;   // Ext_ABSDiskReadWrite
  reg.reg_EBX = (DWORD)&dio;
  reg.reg_ECX = -1;
  reg.reg_EDX = bDrive;   // Int 21h, fn 7305h drive numbers are 1-based

  fResult = DeviceIoControl(hDev, VWIN32_DIOC_DOS_DRIVEINFO,
                            &reg, sizeof(reg),
                            &reg, sizeof(reg), &cb, 0);

  // Determine if the DeviceIoControl call and the read succeeded.
  fResult = fResult && !(reg.reg_Flags & CARRY_FLAG);

  return fResult;
}

BOOL NewWriteSectors (HANDLE hDev, BYTE   bDrive, DWORD  dwStartSector, WORD   wSectors, LPBYTE lpSectBuff)
{
  BOOL           fResult;
  DWORD          cb;
  DIOC_REGISTERS reg = {0};
  DISKIO         dio;

  dio.dwStartSector = dwStartSector;
  dio.wSectors      = wSectors;
  dio.dwBuffer      = (DWORD)lpSectBuff;

  reg.reg_EAX = 0x7305;   // Ext_ABSDiskReadWrite
  reg.reg_EBX = (DWORD)&dio;
  reg.reg_ECX = -1;
  reg.reg_EDX = bDrive;   // Int 21h, fn 7305h drive numbers are 1-based

  reg.reg_ESI = 0x6001;   // Normal file data (See function
                          // documentation for other values)


  fResult = DeviceIoControl(hDev, VWIN32_DIOC_DOS_DRIVEINFO,
                            &reg, sizeof(reg),
                            &reg, sizeof(reg), &cb, 0);

  // Determine if the DeviceIoControl call and the write succeeded.
  fResult = fResult && !(reg.reg_Flags & CARRY_FLAG);

  return fResult;
}

BOOL WINAPI LockLogicalVolumeW95(HANDLE hVWin32, BYTE   bDriveNum, BYTE   bLockLevel, WORD   wPermissions)
{
   BOOL           fResult;
   DIOC_REGISTERS regs = {0};
   BYTE           bDeviceCat;  // can be either 0x48 or 0x08
   DWORD          cb;


   //   Try first with device category 0x48 for FAT32 volumes. If it
   //   doesn't work, try again with device category 0x08. If that
   //   doesn't work, then the lock failed.


   bDeviceCat = 0x48;

retry:
   // Set up the parameters for the call.
   regs.reg_EAX = 0x440D;
   regs.reg_EBX = MAKEWORD(bDriveNum, bLockLevel);
   regs.reg_ECX = MAKEWORD(0x4A, bDeviceCat);
   regs.reg_EDX = wPermissions;

   fResult = DeviceIoControl (hVWin32, VWIN32_DIOC_DOS_IOCTL,
                              &regs, sizeof(regs), &regs, sizeof(regs),
                              &cb, 0);

   // See if DeviceIoControl and the lock succeeded
   fResult = fResult && !(regs.reg_Flags & CARRY_FLAG);

   // If DeviceIoControl or the lock failed, and device category 0x08
   // hasn't been tried, retry the operation with device category 0x08.
   if (!fResult && (bDeviceCat != 0x08))
   {
      bDeviceCat = 0x08;
      goto retry;
   }

   return fResult;
}

BOOL WINAPI UnlockLogicalVolumeW95(HANDLE hVWin32, BYTE bDriveNum)
{
   BOOL           fResult;
   DIOC_REGISTERS regs = {0};
   BYTE           bDeviceCat;  // can be either 0x48 or 0x08
   DWORD          cb;

   // Try first with device category 0x48 for FAT32 volumes. If it
   //   doesn't work, try again with device category 0x08. If that
   //   doesn't work, then the unlock failed.

   bDeviceCat = 0x48;

retry:
   // Set up the parameters for the call.
   regs.reg_EAX = 0x440D;
   regs.reg_EBX = bDriveNum;
   regs.reg_ECX = MAKEWORD(0x6A, bDeviceCat);

   fResult = DeviceIoControl (hVWin32, VWIN32_DIOC_DOS_IOCTL,
                              &regs, sizeof(regs), &regs, sizeof(regs),
                              &cb, 0);

   // See if DeviceIoControl and the unlock succeeded
   fResult = fResult && !(regs.reg_Flags & CARRY_FLAG);

   // If DeviceIoControl or the unlock failed, and device category 0x08 hasn't been tried,
   // retry the operation with device category 0x08.
   if (!fResult && (bDeviceCat != 0x08))
   {
      bDeviceCat = 0x08;
      goto retry;
   }
   return fResult;
}
*/














/*
CFloppyDisk::CFloppyDisk (CStream* pStream_) : CDisk(pStream_)
{
	pStream_->Rewind();

	// Maximum supported geometry
	m_nSides = 2;
	m_nTracks = 83;
	m_nSectors = 10;
	m_nSectorSize = 512;

	// Work out the disk size, allocate some memory for it and read it in
	int nDiskSize = m_nSides * m_nTracks * m_nSectors * m_nSectorSize;
	m_pbData = new BYTE[nDiskSize];

	// Clear the track cache as no tracks are present
	memset(m_abTrackCache, 0, sizeof(m_abTrackCache));
}

bool CFloppyDisk::IsRecognised (CStream* pStream_)
{
#ifdef _WIN32
	return GetDriveType(pStream_->GetName()) == DRIVE_REMOVABLE;
#else
	return false;
#endif
}


// Find the next sector in the current track
bool CFloppyDisk::FindNext (IDFIELD* pIdField_, BYTE* pbStatus_)
{
	bool fRet = CDisk::FindNext();

	// Make sure there is a 'next' one
	if (fRet)
	{
		// Construct a normal ID field for the sector
		pIdField_->bSide = m_nSide;
		pIdField_->bTrack = m_nTrack;
		pIdField_->bSector = m_nSector;
		pIdField_->bSize = 2;						// 512 bytes
		pIdField_->bCRC1 = pIdField_->bCRC2 = 0;

		// Sector OK
		*pbStatus_ = 0;
	}

	// Return true if we're returning a new item
	return fRet;
}

// Read the data for the last sector found
BYTE CFloppyDisk::ReadData (BYTE *pbData_, UINT* puSize_)
{
	HANDLE hDevice = reinterpret_cast<CFloppyStream*>(m_pStream)->m_hDevice;
	DWORD dwRet;
	BOOL f;


	DIOC_REGISTERS regs = { 0 };
	regs.reg_EAX  = 0x1600;
	regs.reg_EDX  = 0x0000;

	f = DeviceIoControl(hDevice, VWIN32_DIOC_DOS_INT13, &regs, sizeof(regs), &regs, sizeof(regs), &dwRet, 0);

	// If the disk has changed, clear the track cache
	if (regs.reg_Flags & 1)
	{
		memset(m_abTrackCache, 0, sizeof(m_abTrackCache));

		regs.reg_EAX  = 0x0000;
		regs.reg_EDX  = 0x0000;

		f = DeviceIoControl(hDevice, VWIN32_DIOC_DOS_INT13, &regs, sizeof(regs), &regs, sizeof(regs), &dwRet, 0);
		TRACE("AX=%#04hx  Carry=%d\n", HIWORD(regs.reg_EAX), regs.reg_Flags & 1);
	}

	// Work out the offset for the required data
	long lPos = (m_nSide * m_nSides + m_nTrack) * (m_nSectors * m_nSectorSize);

	// Read the track if not already cached (re-read if start of directory)
	int nTrackPos = (m_nSide * m_nTracks + m_nTrack);
	BYTE* pb = m_pbData + nTrackPos * (m_nSectors * m_nSectorSize);

	if (!(m_abTrackCache[nTrackPos >> 3] & (1 << (nTrackPos & 7))))
	{
		memset(pb, 0xcd, m_nSectors * m_nSectorSize);

		for (int i = 0 ; i < 3 ; i++)
		{
			regs.reg_EAX  = 0x020a;								// read 10 sectors
			regs.reg_EBX  = reinterpret_cast<DWORD>(pb);
			regs.reg_ECX  = (m_nTrack << 8) | 1;
			regs.reg_EDX  = (m_nSide << 8) | 0x00;				// head 1 on drive A
			regs.reg_Flags = 0x0001;							// error flag

			dwRet = 0;
			f = DeviceIoControl(hDevice, VWIN32_DIOC_DOS_INT13, &regs, sizeof(regs), &regs, sizeof(regs), &dwRet, 0);

			if (f && !(regs.reg_Flags & 1) && ((regs.reg_EAX & 0xff) == 0x0a))
				break;
		}

		if (!f || (regs.reg_Flags & 1))
			return RECORD_NOT_FOUND;

		// Mark the track as present
		m_abTrackCache[nTrackPos >> 3] |= (1 << (nTrackPos & 7));
	}

	// Copy the sector data
	pb += (m_nSector-1) * m_nSectorSize;
	if (*(DWORD*)pb == 0xcdcdcdcd)
		_asm int 3
	memcpy(pbData_, pb, *puSize_ = m_nSectorSize);

	// Data is always perfect on DSK images, so return OK
	return 0;
}

// Read the data for the last sector found
BYTE CFloppyDisk::WriteData (BYTE *pbData_, UINT* puSize_)
{
	// Work out the offset for the required data
	long lPos = (m_nSide * m_nTracks + m_nTrack) * (m_nSectors * m_nSectorSize) + ((m_nSector-1) * m_nSectorSize);

	// Copy the sector data
	memcpy(m_pbData + lPos, pbData_, *puSize_ = m_nSectorSize);

	// Data is always perfect on DSK images, so return OK
	return 0;
}

bool CFloppyDisk::Save ()
{
	// Eveything's currently written immediately, but we'll need to do more when caching is added
	return true;
}
*/


/* INT 13  (BIOSDISK)

0 - reset disk subsystem 
1 - get disk subsystem status 
2 - read one or more sectors 
3 - write one or more sectors 
5 - format a track 
6 - format back track 
7 - format drive 
8 - get drive parameters 
9 - initialize drive parameters 
10 - read long sectors 
11 - write long sectors 
12 - seek to cylinder 
13 - alternate fixed disk reset 
14 - read test buffer 
15 - write test buffer 
16 - test for drive ready 
17 - recalibrate drive 
18 - controller RAM diagnostic 
19 - controller drive diagnostic 
20 - controller internal diagnostic 
15 - read fixed disk type 
22 - read disk change line status 
23 - set DASD type (pass dasd in nsects) 
24 - set media type for format 

The first request with more sectors than will fit in the transfer buffer will cause a DOS buffer to be allocated. This buffer is automatically freed when your application exits. Since this buffer is big enough to hold 18 sectors, requests for more sectors than that will fail. 

Request eight returns values in buffer as follows: 

byte 0 = sectors per track (bits 0..5) and top two bits of cylinder (in bits 6..7) 
byte 1 = cyliders (bits 0..7) 
byte 2 = number of drives 
byte 3 = number of heads 
Return Value
The value of AH returned by the BIOS. 


*/
