#include "stdafx.h"

#include <dsound.h>

#include "Parallel.h"
#include "Options.h"
#include "Sound.h"
#include "IO.h"

void Dump (void* pvData_, DWORD dwData_);

extern CStreamingSound* pDAC1;


namespace Parallel
{

bool Init ()
{
	Exit();

//	pDAC = new CSAMDAC;
//	pDAC1 = new CMonoDAC;

	return true;
}

void Exit ()
{
//	if (pDAC1) { delete pDAC1; pDAC1 = NULL; }
}


BYTE In (WORD wPort_)
{
	switch (GetOption(parallel1))
	{
		case 1:
		{
			switch (wPort_ & PRINTL_MASK)
			{
				case PRINTL1_STAT:
				case PRINTL2_STAT:
					return 0x80;		// We're always ready to print
			}
			break;
		}
	}

	return 0;
}

BYTE b;
void Out (WORD wPort_, BYTE bVal_)
{
	switch (GetOption(parallel1))
	{
		default:
			break;

		case 1:
		{
			// Printer stuff in here
			break;
		}

		case 2:
		{
			if (!(wPort_ & 3))
				((CMonoDAC*)pDAC1)->Update(false, bVal_);
				break;
		}

		case 3:
		{
			switch (wPort_ & 3)
			{
				case 0:
					b = bVal_;
					break;

				case 1:
				{
					if (bVal_ == 0)
					{
						pDAC1->Update();
						((CStereoDAC*)pDAC1)->m_bRight = b;
					}
					else if (bVal_ == 1)
					{
						pDAC1->Update();
						((CStereoDAC*)pDAC1)->m_bLeft = b;
					}
					break;
				}
			}
			break;
		}
	}

/*
	// If the STROBE bit is set (so STROBE signal is low, due to inverted logic), a byte is available
	if (bVal_ & 0x01)
	{
	}
*/
	// Printer port 1 data - note that nothing is done with it until the STOBE signal is lowered
}

};	// namespace Parallel


/*	From: http://www.mono.org/~unc/Coupe/tech/comms.html

	The SAM allows 8 i/o ports for the comms interface - PRINTL on the expansion port goes low when any of these
	are being addressed. Ports 232 & 233 are for parallel printer port#1, 234 & 235 for parallel printer port#2,
	and 236-239 are for the serial interface, which we won't cover here.

	How do you send a byte to the printer? First read port 233 - if bit 0 is set to '1' then the printer is busy
	and is not ready to accept any data - so keep on testing bit 0 until it becomes logic '0'. Next output your
	byte to port 232 then output 01 to port 233, wait for 1 microsecond and then output 00. Doing this pulls the
	printer's /STROBE line low temporarily, telling it that there is a byte for it to print. (/STROBE is fed with
	an inverted version of bit 0.) For printer port#2, just use ports 234 & 235 in place of 232 & 233 respectively.

	PRINTL on the expansion port is low whenever an i/o port in the range 232 to 239 is being addressed.

	Note that the serial interface actually uses address line 8, 9 & 10 to access different registers of the ACIA,
	and that a0 and a1 are used to select which comms interface you are talking to - up to 4 serial ports can be
	added, each given a different address set by internal jumpers.
*/
